//#define ENABLE_SERIAL_DEBUG
#define MORE_SIGN_MODES
#define DISPLAY_ANIMATE_PIXEL
//#define DISPLAY_CROSS_HAIRS
//#define DISPLAY_BOUNDING_BOX

//Easy way to make sure code doesn't get bloated with a missed Serial.print left in code
#ifdef ENABLE_SERIAL_DEBUG
  #define debugPrint(...)    Serial.print(__VA_ARGS__)
  #define debugPrintln(...)  Serial.println(__VA_ARGS__)
  #define debugPrintF(...)   Serial.print(F(__VA_ARGS__))
  #define debugPrintlnF(...) Serial.println(F(__VA_ARGS__))
#else
  #define debugPrint(...)     //blank line
  #define debugPrintln(...)   //blank line
  #define debugPrintF(...)    //blank line
  #define debugPrintlnF(...)  //blank line
  #define Serial breakme      //Will cause a compiler error if I accidently used Serial.print
#endif


//Macros from DateTime.h 
/* Useful Constants */
#define SECS_PER_MIN  (60UL)
#define SECS_PER_HOUR (3600UL)
#define SECS_PER_DAY  (SECS_PER_HOUR * 24L)

/* Useful Macros for getting elapsed time */
#define numberOfSeconds(_time_) (_time_ % SECS_PER_MIN)  
#define numberOfMinutes(_time_) ((_time_ / SECS_PER_MIN) % SECS_PER_MIN) 
#define numberOfHours(_time_) (( _time_% SECS_PER_DAY) / SECS_PER_HOUR)
#define elapsedDays(_time_) ( _time_ / SECS_PER_DAY)  


//For the neopixels
#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
  #include <avr/power.h>
#endif


//For the 128x64 OLED
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#define OLED_RESET 4
#define OLED_I2C 0x3C//.96"
//Adafruit_SSD1306 display(OLED_RESET);
//#if (SSD1306_LCDHEIGHT != 64)
//  #error("Height incorrect, please fix Adafruit_SSD1306.h!");
//#endif
Adafruit_SSD1306 display(128, 64, &Wire, OLED_RESET);


//Custom fonts
#include "fonts/ubuntu-07-full.h"
#include "fonts/impact-11-full.h"     //2312 bytes
#include "fonts/impact-14-numbers.h"  //422 bytes
#include "fonts/impact-27-numbers.h"  //1388 bytes
#define MENUFONT &Ubuntu_R7pt7b
const byte menuFontHeight=11;

//For the external RTC
#include <RtcDS3231.h>
#include <EepromAt24C32.h>
RtcDS3231<TwoWire> RTC(Wire);
EepromAt24c32<TwoWire> RTCEEPROM(Wire);

//DO NOT USE PIN 9 or 10 for PWM when using timer 1.
//Only pins 2 and 3 can have ISR attached
const byte ballDetectPin =  2;
const byte secPossyncPin    =  3;// +ve pulse sync
const byte secsyncPin    =  4;// -ve pulse sync
int secsync               =0;
int secsReady = 0; // lets 30 sec sync only between seconds set
int Secondtimer = 0; // stops motor stopping early before 1 second
const byte motorPin      =  5;
const byte button1Pin    =  8;
const byte button2Pin    =  7;
const byte button3Pin    =  6;//Brightness Pin
const byte PIRPin        = 13;// PIR sensor input pin
int PIROn                = 0;
int Brightness           =  30;//Brightness value
int secondcheck          =  0;
const byte neoPixelPin   =  11;
//const byte LED           = 13; //The built in LED

const byte numLEDs      = 50;//20
const byte firstSignLED = 0;//0
const byte lastSignLED  = 44;//17
const byte liftTubeLED  = 45;//18
const byte panelLED     = 46;//19
const byte SecSyncLED   = 47;
const byte SecSyncLEDa  = 48;
const byte PowerLED   = 49;
/*
const byte numLEDs      = 7;//7
const byte panelLED     = 0;//0
const byte firstSignLED = 1;//1
const byte lastSignLED  = 5;//5
const byte liftTubeLED  = 6;//6
*/

Adafruit_NeoPixel strip = Adafruit_NeoPixel(numLEDs, neoPixelPin, NEO_GRB + NEO_KHZ800);
#define off    strip.Color(0,0,0)
#define red    strip.Color(255,0,0)
#define green  strip.Color(0,255,0)
#define blue   strip.Color(0,0,255)
#define cyan   strip.Color(0,255,255)
#define yellow strip.Color(255,255,0)
#define purple strip.Color(255,0,255)
#define white  strip.Color(255,255,255)
