void updateMasterTimeFromRTC()
{
  //Get time from external RTC
  //Sometimes get a bad read from the external RTC, so read it twice and make sure it matches or 
  //that the difference is not greater than 1 second (because the time actually increased between the two reads).
  //If there is an error, then just return and it will get updated the next time through the loop.
  //Much better option than having the motorState change because of a bad value!!
  RtcDateTime now = RTC.GetDateTime();
  RtcDateTime now2 = RTC.GetDateTime(); 

      
      
if (now.Second() >= 1)
 {   
Secondtimer = 1; 
 }
 else Secondtimer = 0;
      
     if (now.Second() == 10  )
     {
      secsync = 1; 
     }
      
      
      // Allow 30 second sync after seconds get to 25
      if (now.Second() >= 25 && now.Second() <= 35 )
 {   
secsReady = 1; 
 }
 else
 secsReady = 0;

//Power LED color change
 if (now.Second() >= 0 && now.Second() <= 9)
 {   
PowerLEDColor=red; 
 }

else if (now.Second() >= 10 && now.Second() <= 19)
 {   
PowerLEDColor=blue; 
 }
 
else if (now.Second() >= 20 && now.Second() <= 29)
 {   
PowerLEDColor=green; 
 }

else if (now.Second() >= 30 && now.Second() <= 39)
 {   
PowerLEDColor=cyan; 
 }

else if (now.Second() >= 40 && now.Second() <= 49)
 {   
PowerLEDColor=purple; 
 }

 else if (now.Second() >= 50 && now.Second() <= 59)
 {   
PowerLEDColor=yellow; 
 }
 
    
  uint32_t readDiff=now2.TotalSeconds()-now.TotalSeconds();
  if (readDiff > 1)
  {
    rtcBadReads++;
    return;
  }

  //Don't need to do anything if the seconds haven't changed
  if (now2.Second()==masterTime.Second()) 
    return;

  secondChanged=true;
  
  if (now2.Second() < masterTime.Second())
    minuteChanged=true;

  masterTime=now2;
}


void checkIfNeedToBeQuietOrWakeUp()
{
  //If not enabled and put into quiet mode manually, then need to wake up manually
  if (persistentData.quietTimeEnabled==false)
    return;

  boolean inQuietTimeRange=isItQuietTimeNow();
  
  if (inQuietModeNow) //Then check to see if need to wake up
  {
    if (inQuietTimeRange)
    {
      if (quietTimeStartOverride)
        quietTimeStartOverride=false;
    }
    else if (quietTimeStartOverride==false)
      endQuietTimeMode(); 
  }
  else //Then check to see if need to be quiet
  {
    if (inQuietTimeRange)
    {
      if (quietTimeEndOverride==false)
        startQuietTimeMode();
    }
    else
      quietTimeEndOverride=false;    
  }
}


void handleSignRainbowMode()
{
  static unsigned long lastSignLEDChangeMillis=0;  
  static uint16_t j=256*5;
 
  //If sign is in rainbow mode
  if (persistentData.signMode==1)
  {
    unsigned long currentMillis = millis();
    if ((currentMillis - lastSignLEDChangeMillis) > rainbowMinDelay)
    {
      for(int i=firstSignLED; i<= lastSignLED; i++)
        strip.setPixelColor(i, Wheel(((i * 256 / strip.numPixels()) + j) & 255));
        
      neoPixelUpdated=true;
      j--;
      lastSignLEDChangeMillis=currentMillis;
    }
  }

  if (j==0)
    j=256*5;
}



void handleMotorStateForNormalAndDemoModes()
{   
  if (mode==0) //In normal mode
  { 
    if (secondChanged)
    {
      forceDisplayUpdate=true;
      
      if (minuteChanged && displayState!=WAIT)
      {
        motorState++;
        //minuteChanged=false;
      }
      //secondChanged=false;
    }
  }
  else //In one of the demo modes
  {
    static int lastDemoCountdownTimer=0;
    static unsigned long demoTargetMotorOnMillis=0;
    
    if (forceDisplayUpdate==false && mode==1)  //Motor is already on, don't need to do anything
      return;
        
    unsigned long currentMillis=millis();
      
    if (lastDemoCountdownTimer<=0 || forceDisplayUpdate==true)
      demoTargetMotorOnMillis=currentMillis+(mode-1)*1000;

    if (mode > 1 && motorState==0)
      demoCountdownTimer=demoTargetMotorOnMillis-currentMillis;
    
    if (demoCountdownTimer != lastDemoCountdownTimer || forceDisplayUpdate==true)
    {
      if (mode==1)  
      {   
        motorState=1;
      }
      else
      {      
        if (demoCountdownTimer <= 0 && forceDisplayUpdate==false)
          motorState=1;
          
        lastDemoCountdownTimer=demoCountdownTimer; 
      }

      if (displayState==TIME_OR_DEMO)
        forceDisplayUpdate=true;
    }
  }
}


void motorOnOrOff()
{
  //Turn motor on or off based on motorState
 
  if (!motorOn && motorState > 0)
    turnMotorOn();
  else if (motorOn && motorState <= 0)
    turnMotorOff();
}


void serviceBallDetectISR()
{
  //Enable or disable the ballDetectISR as needed
  unsigned long currentMillis=millis();
  
  if (ballDetectISRAttached==true && ballDetectISRCount>0)  
  {
    if ((currentMillis-lastBallDetectMillis)>ISRDetachMillis)
    {
      //Update ball delivery stats
      lastBallDetectMillis=currentMillis;
      lastBallDeliveryMillis=lastBallDetectMillis-motorTurnedOnMillis;
      /*
      ballCount++;
      totalBallDeliveryMillis+=lastBallDeliveryMillis;
      lastBallDeliveryTime=(float)lastBallDeliveryMillis/1000;
      if (lastBallDeliveryTime < minBallDeliveryTime)
         minBallDeliveryTime=lastBallDeliveryTime;
      if (lastBallDeliveryTime > maxBallDeliveryTime)
         maxBallDeliveryTime=lastBallDeliveryTime;
      */
      
      if (mode != 1)
      {
        //Ball has been delivered, turn motor off if all needed balls have been delivered
        motorState--;
        if (motorState < 0)
          motorState=0;
        forceDisplayUpdate=true;

        //Update motorTurnedOnMillis to prevent timeout
        if (displayState==SYNC)
          motorTurnedOnMillis=currentMillis;
      }
      else  //In continuous demo mode, update motorTurnedOnMillis to prevent timeout
        motorTurnedOnMillis=currentMillis;  
        
      //Used to syncronize after waking up, power outage, and after fixing ball delivery error
      if (mode==0)
      {
        ballsDelivered++;
        storeBallsDeliveredToRTC();
      }
    }
  
    detachInterrupt(digitalPinToInterrupt(ballDetectPin));
    ballDetectISRAttached=false;
  }

 // added Secondtimer so motor starting does not false trigger ball detect
   
   if (Secondtimer > 0  )       //was if (Secondtimer >= 1) only detects balls after 1 second
   {
  if (ballDetectISRAttached==false && ((currentMillis - lastBallDetectMillis) > ISRDetachMillis ))  // && masterTime.Second() >= 1
  {
   // Serial.print("Secondtimer ");
   // Serial.println(Secondtimer);
    attachInterrupt(digitalPinToInterrupt(ballDetectPin), ISR_ballDetect, RISING);//changed to 10K pull down resistor RISING not FALLING
    ballDetectISRAttached=true;
    ballDetectISRCount=0;
  }
  
}
}
/*
void updateSecSyncLED()
{
  if (secsync == 1)
  {
    SecSyncLEDColor=purple;
  }
   if (digitalRead(secsyncPin) == HIGH)
  {
    SecSyncLEDColor=green;
  }
  
}

*/
void updateFrontPanelLED()
{
  //Set front panel LED color
  unsigned long currentMillis=millis();
  
  panelLEDColor=off;

  //Panel LED green when ball is detected
  if (ballDetectISRAttached == false)           
    panelLEDColor=green;
  else
  {
    //In normal mode but it's the next minute and a ball hasn't been delivered for the previous minute
    if (motorState>1)   
      panelLEDColor=yellow;
  
    //In demo mode but 60 seconds since last ball delivered
    if (mode>0 && motorState>0 && (currentMillis-motorTurnedOnMillis)>((unsigned long)60*1000))  
      panelLEDColor=yellow;

    //In sync mode
    if (displayState==SYNC)
      panelLEDColor=blue;

    //In wait mode
    if (displayState==WAIT)
      panelLEDColor=purple;
    
    //In either mode but ballDeliveryTimeout has been reached
    unsigned long timeOn=currentMillis-motorTurnedOnMillis;
    if (motorState>0 && (timeOn)>((unsigned long)ballDeliveryTimeout*1000))  
    {
      panelLEDColor=red;
      startBallDeliveryError();
    }
  }
}


void updateDisplayBufferAndHandleButtonActions()
{     
  static boolean incField=false;
  static unsigned long buttonPressedMillis=0;
  static unsigned long buttonDownMillis=0;
  unsigned long currentMillis=millis();

  //If displayState is in a normal mode then change state when button2 is pressed
  if (displayState<LAST && isButtonPressed(&button2History))
    incrementDisplayState();
  
  switch (displayState)
  {
    case TIME_OR_DEMO:
        writeSecondsOrDemoScreenToBuffer();
        
        if (isButtonPressed(&button1History))
          changeSignMode();
        break;
        
    case CHANGE_MODE: 
        writeChangeModeScreenToBuffer();
        
        if (isButtonPressed(&button1History))
          changeMode(); //also sets forceDisplayUpdate=true
        break;
        
    case RESET_SECONDS:
        writeTitleActionScreenToBuffer(F("Reset Seconds:"), 93, F("reset")); 

        if (isButtonPressed(&button1History))
        {
          resetSeconds();  //also sets forceDisplayUpdate=true
          displayState=TIME_OR_DEMO;
        }
        break;

    case QUIET_NOW:
        writeTitleActionScreenToBuffer(F("Quiet Mode Now:"), 107, F("sleep now")); 

        if (isButtonPressed(&button1History))
        {
          startQuietTimeMode();  
          quietTimeStartOverride=true;
          displayState=TIME_OR_DEMO;
        }
        break;
        
    case QUIET_SETUP:
        writeTitleActionScreenToBuffer(F("Quiet Time Setup:"), 111, F("change")); 

        if (isButtonPressed(&button1History))
        {
          displayState=MOD_QUIET_SETTINGS;
          quietSetupFieldPtr=0;
          interQuietTimeStartHour=persistentData.quietTimeStart/60;
          interQuietTimeStartMinute=persistentData.quietTimeStart%60;
          interQuietTimeEndHour=persistentData.quietTimeEnd/60;
          interQuietTimeEndMinute=persistentData.quietTimeEnd%60;
          interCurrentTimeHour=masterTime.Hour();
          interCurrentTimeMinute=masterTime.Minute();
          currentTimeChanged=false;
          interQuietTimeEnabled=persistentData.quietTimeEnabled;
          buttonPressedMillis=0;
          forceDisplayUpdate=true;
        }
        break;
    
    case MOD_QUIET_SETTINGS:
        writeModQuietSettingsScreenToBuffer();

        if (isButtonPressed(&button1History))
        {
          buttonPressedMillis=currentMillis;
          incField=true;
        } 
        else if (buttonPressedMillis!=0 && isButtonDown(&button1History) && currentMillis>buttonPressedMillis+buttonHoldMinimumMillis)
        {
          if (currentMillis > buttonDownMillis+buttonHoldRepeatMillis)
          {
            buttonDownMillis=currentMillis;
            incField=true;
          }
        }
          
        if (incField)
        {
          incField=false;
          switch(quietSetupFieldPtr)
          {
            case 0:
              incByte(interCurrentTimeHour, 23);
              currentTimeChanged=true;
              break;
            case 1:
              incByte(interCurrentTimeMinute, 59);
              currentTimeChanged=true;
              break;
            case 2:
              incByte(interQuietTimeEnabled, 1);
              break;
            case 3:
              incByte(interQuietTimeStartHour, 23);
              break;
            case 4:
              incByte(interQuietTimeStartMinute, 59);
              break;
            case 5:
              incByte(interQuietTimeEndHour, 23);
              break;
            case 6:
              incByte(interQuietTimeEndMinute, 59);
              break;
            case 7:
              //Saved was selected
              persistentData.quietTimeEnabled=interQuietTimeEnabled;
              persistentData.quietTimeStart=interQuietTimeStartHour*60+interQuietTimeStartMinute;
              persistentData.quietTimeEnd=interQuietTimeEndHour*60+interQuietTimeEndMinute;
              persistentDataChanged=true;
              if (currentTimeChanged)
              {
                setMasterTime(interCurrentTimeHour, interCurrentTimeMinute, masterTime.Second());
                currentTimeChanged=false;
              }
              //Don't break, fall through
            case 8:
              //Exit was selected
            default:
              displayState=TIME_OR_DEMO;
              break;
          }
                     
          forceDisplayUpdate=true;
        }
        
        if (isButtonPressed(&button2History))
        {
          incByte(quietSetupFieldPtr, 8);  
          forceDisplayUpdate=true;
        }
        break;
        
    case STATS1:
        writeStatsScreenToBuffer(1);
       
        if (isButtonPressed(&button1History))
        {
          displayState=TIME_OR_DEMO;
          forceDisplayUpdate=true;
        }
        break;
    /*
    case STATS2:
        writeStatsScreenToBuffer(2);
       
        if (isButtonPressed(&button1History))
        {
          displayState=TIME_OR_DEMO;
          forceDisplayUpdate=true;
        }
        break;
    */
    
    case SYNC:
        //Cancel if either button pressed
        if (isButtonPressed(&button1History) || isButtonPressed(&button2History))
        {
          motorState=0;
          //If canceling need to get ballsDelivered and total minutes from the RTC matched back up
          initializeBallsDeliveredToRTC();
        }

        //Done now, or canceled
        if (motorState==0)
        {
          displayState=TIME_OR_DEMO;
          forceDisplayUpdate=true;
          return;
        }

        writeSyncScreenToBuffer();
        break;
    case WAIT:
        //Cancel if either button pressed
        if (isButtonPressed(&button1History) || isButtonPressed(&button2History))
        {
          minutesLeftToWait=0;
          //If canceling need to get ballsDelivered and total minutes from the RTC matched back up
          initializeBallsDeliveredToRTC();
        }

        if (minuteChanged)
        {
          minutesLeftToWait--;
          forceDisplayUpdate=true;
        }
        
        //Done now, or canceled
        if (minutesLeftToWait==0)
        {
          displayState=TIME_OR_DEMO;
          forceDisplayUpdate=true;
          return;
        }

        writeWaitScreenToBuffer();
        break;
  } 
}


void writeDirtyDisplayBuffer()
{
  //Write the display buffer to the display if needed
  if (displayUpdated == true)
  {
    displayUpdated=false;

    //Draw bounding box
    #ifdef DISPLAY_BOUNDING_BOX
      display.drawLine(0, 0, display.width()-1, 0, WHITE);
      display.drawLine(0, display.height()-1, display.width()-1, display.height()-1, WHITE);
      display.drawLine(0, 0, 0, display.height()-1, WHITE);
      display.drawLine(display.width()-1, 0, display.width()-1, display.height()-1, WHITE);
    #endif

    //Draw cross hairs
    #ifdef DISPLAY_CROSS_HAIRS
      //Vertical
      display.drawLine(63, 0, 63, 63, WHITE);
      display.drawLine(64, 0, 64, 63, WHITE);

      //Horizontal
      display.drawLine(0, 31, 127, 31, WHITE);
      display.drawLine(0, 32, 127, 32, WHITE);
    #endif

    //Animate pixel across top to see when display is updated
    #ifdef DISPLAY_ANIMATE_PIXEL
      static byte dotPos=0;
      display.drawPixel(dotPos, 0, WHITE);
      dotPos++;
      if (dotPos==128)
        dotPos=0;
    #endif

    display.display();
  }
}


void writeEEPROMIfNeeded()
{
  if (persistentDataChanged)
  {
    writePersistentDataToEEPROM();
    persistentDataChanged=false;
  }
}


void updateNeoPixelsIfNeeded()
{
  if (strip.getPixelColor(panelLED) != panelLEDColor)
  {
    strip.setPixelColor(panelLED, panelLEDColor);
    neoPixelUpdated=true;
  }

  if (strip.getPixelColor(liftTubeLED) != liftTubeLEDColor)
  {
    strip.setPixelColor(liftTubeLED, liftTubeLEDColor);
    neoPixelUpdated=true;
  }

  if (strip.getPixelColor(SecSyncLED) != SecSyncLEDColor)
  {
    strip.setPixelColor(SecSyncLED, SecSyncLEDColor);
    neoPixelUpdated=true;
  }
  
 if (strip.getPixelColor(SecSyncLEDa) != SecSyncLEDColora)
  {
    strip.setPixelColor(SecSyncLEDa, SecSyncLEDColora);
    neoPixelUpdated=true;
  }

  if (strip.getPixelColor(PowerLED) != PowerLEDColor)
  {
    strip.setPixelColor(PowerLED, PowerLEDColor);
    neoPixelUpdated=true;
  }
  
  if (neoPixelUpdated==true)
  {
    strip.show();
    neoPixelUpdated=false;
  } 
}
