void setup()
{ 
  #ifdef ENABLE_SERIAL_DEBUG
    Serial.begin(115200); 
    debugPrintln("Started ...");
  #endif

  //Setup the pins
  pinMode(PIRPin, INPUT);
  pinMode(motorPin, OUTPUT);
  pinMode(button1Pin, INPUT_PULLUP);
  pinMode(button2Pin, INPUT_PULLUP);
  pinMode(button3Pin, INPUT_PULLUP);
  pinMode(ballDetectPin, INPUT); //changed to 10K pull down resistor wasinput pullup
  pinMode(secsyncPin, INPUT_PULLUP);
   // attachInterrupt(digitalPinToInterrupt(secsyncPin), ISR_secsync, FALLING);
    attachInterrupt(digitalPinToInterrupt(ballDetectPin), ISR_ballDetect, RISING); //changed to 10K pull down resistor RISING not FALLING
  //pinMode(LED, OUTPUT);


  //For OLED and RTC
  Wire.begin();  

  //RTC setup
  RTC.Begin();
  RTC.SetIsRunning(true);
  RTCEEPROM.Begin();

  //For neoPixels
  strip.begin();

  //Setup for OLED, internal voltage source for display
  display.begin(SSD1306_SWITCHCAPVCC, OLED_I2C); 
  
  //Read persistent data from EEPROM
  if (readPersistentDataFromEEPROM() == false)
  {
    //Didn't find valid data in eeprom so initialize
    persistentData.signMode=1;
    persistentData.quietTimeStart=60*2; //2am
    persistentData.quietTimeEnd=60*9;  //9am
    persistentData.quietTimeEnabled=false;
    persistentDataChanged=true;
  }

  //If in quiet mode then start quiet mode
  if (persistentData.quietTimeEnabled && isItQuietTimeNow())
    startQuietTimeMode();
  else
    endQuietTimeMode();  
    
  setSignLEDColor();
    

  //Setup timer1 to generate periodic interrupts to scan buttons
  //Code generated from http://www.8bit-era.cz/arduino-timer-interrupts-calculator.html
  cli(); // stop interrupts
  TCCR1A = 0; // set entire TCCR1A register to 0
  TCCR1B = 0; // same for TCCR1B
  TCNT1  = 0; // initialize counter value to 0
  // set compare match register for 50 Hz increments (every 5 milliseconds)
  OCR1A = 39999; // = 16000000 / (8 * 50) - 1 (must be <65536)
  // set compare match register for 100 Hz increments (every 10 milliseconds)
  //OCR1A = 19999; // = 16000000 / (8 * 100) - 1 (must be <65536)
  // turn on CTC mode
  TCCR1B |= (1 << WGM12);
  // Set CS12, CS11 and CS10 bits for 8 prescaler
  TCCR1B |= (0 << CS12) | (1 << CS11) | (0 << CS10);
  // enable timer compare interrupt
  TIMSK1 |= (1 << OCIE1A);
  sei(); // allow interrupts
}//end setup
