void changeSignMode()
{
  incByte(persistentData.signMode, maxSignModes);
  persistentDataChanged=true;
  setSignLEDColor();
  debugPrint("sign mode=");
  debugPrintln(persistentData.signMode);
}


void setSignLEDColor()
{
  for(int i=firstSignLED; i<= lastSignLED; i++)
    switch (persistentData.signMode)
    {
      case 0:
        strip.setPixelColor(i, off); 
        break;
      case 1:
        //Rainbow mode handled seperately
        break;
      case 2:     
        strip.setPixelColor(i, blue);   
        break;
      case 3: 
        strip.setPixelColor(i, green);  
        break;
      case 4:   
        strip.setPixelColor(i, cyan); 
        break;
    #ifdef MORE_SIGN_MODES
      //My sign front is a dark blue which absorbs red, so don't need these colors
      case 5:
        strip.setPixelColor(i, yellow);
        break;
      case 6:
        strip.setPixelColor(i, purple);
        break;
      case 7:
        strip.setPixelColor(i, red);
        break;
      case 8:
        strip.setPixelColor(i, white);
        break;
    #endif
      default:
        break;
    }  
      
  strip.show();
}


uint32_t Wheel(byte WheelPos)
{
  //From the Adafruit lib demo
  
  // Input a value 0 to 255 to get a color value.
  // The colours are a transition r - g - b - back to r.
  
  WheelPos = 255 - WheelPos;
  if(WheelPos < 85)
    return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  
  if(WheelPos < 170)
  {
    WheelPos -= 85;
    return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
  
  WheelPos -= 170;
  return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
}
